#include <stdio.h>
#include <math.h>

int f(int *x,int n,int m) {
  int kk,i ;
  for (kk=0,i=0;i<n;i++)
    kk+=x[i]/m ;
  return kk ;
}

int binom(int *x,int n,int k,int l,int h) {
  int m,kk ;

  m=((long)l+(long)h)/2 ;
  kk=f(x,n,m) ;
  /* printf("l=%d h=%d m=%d kk=%d\n",l,h,m,kk) ;    */

  if (kk==k) return m ; 
  if (l==m) return m ; 
  if (kk<=k) return binom(x,n,k,l,m) ;
              else return binom(x,n,k,m,h) ;
  
}

int binom3(int *x,int n,int k,int l,int h) {
  int m,kk0,kk1 ;

  m=((long)l+(long)h)/2 ;
  kk0=f(x,n,m) ;
  kk1=f(x,n,m+1) ;
  /* printf("l=%d h=%d m=%d kk0=%d kk1=%d\n",l,h,m,kk0,kk1) ;   */
  
  if (kk0>=k && kk1<k) return m ;
  if (l==m && kk0<k) return 0 ;
  if (kk0<k) return binom3(x,n,k,l,m) ;
  else return binom3(x,n,k,m,h) ;
  
}

int binom2(int *x,int n,int k,int l,int h) {
  int m1,m2 ;

  m1=binom(x,n,k,l,h) ;
  if (k>1)   m2=binom(x,n,k-1,l,h) ;
  else m2=2*m2 ;
	       

  /* printf("m1=%d m2=%d\n",m1,m2) ;   */

  return binom3(x,n,k,m1,m2+1) ;

}

void solve(n,k) {
  int x[n],i ;
  double xx ;

  for (i=0;i<n;i++) {
    scanf("%lf ",&xx) ;
    x[i]=(int)floor(100.0*xx+0.5) ;
    /* printf("x[%d]=%d %f\n",i,x[i],xx) ;  */
  }

  printf("%.2f\n",0.01*(double)binom2(x,n,k,1,11000000)) ;

}



int main() {
  int n,k ;

  for(;;) {
    scanf("%d %d ",&n,&k) ;
    if (n==0 || k==0) break ;
    solve(n,k) ;
  }

  return 0 ;
}
