#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define M_PI		3.14159265358979323846

int cmpr(float *x,float *y) {
  if (*x>*y) return 1 ; else
    { if (*x<*y) return -1 ; else return 0.0 ; }
}
  
int visible(float x,float y) {
  float r = y-x ;
  while (r>2.0*M_PI) r-=2.0*M_PI ;
  while (r<0.0) r+=2.0*M_PI ;
  return r<M_PI ;
}


void solve(float tx,float ty, float r,int n) {
  float a[n] ; int i,j,m ; int x, y ; float dx,dy ; int len,best,end ;

  for(i=0,m=0;i<n;i++) {
    scanf("%d %d ",&x,&y) ;
    dx=x-tx ; dy=y-ty ;
    if (dx*dx+dy*dy>r*r) continue ;
    a[m]=atan2(dy,dx) ;
#if 0
    printf ("m=%d x=%d y=%d a=%g\n",m,x,y,a[m]) ;
#endif
    m++ ;
  }
  
  if (m==0) { printf("0\n") ; return ; }

  qsort(a,m,sizeof(float),cmpr) ;

#if 0
  for (i=0;i<m;i++) 
    printf("a[%d]=%g\n",i,a[i]) ;
#endif

  for (len=1,j=1;j<m;j++) {
    if (!visible(a[0],a[j])) { 
#if 0
      printf("a[%d] is not visible\n",j) ;
#endif
      break ; }
#if 0
    printf("a[%d] is visible\n",j) ;
#endif
    len++ ;
  }

#if 0
  printf("m=%d len=%d\n",m,len) ;
#endif

  best=len ; end=len-1 ; /* the last visible */
  for (i=0;i<m;) {
#if 0
  printf("i=%d end=%d\n",i,end) ;
#endif

    while ((end+1)%m!=i && visible(a[i],a[(end+1)%m])) { 
#if 0
      printf("a[%d] is visible from a[%d], len=%d\n",(end+1)%m,i,len+1) ;
#endif
      len++ ; end=(end+1)%m ;
      if (len>best) best=len ; 
      if (len==m) break ;
    }
    if (best==m) break ;
    i++ ; len-- ;
    if (len<1) { end=i ; len=1 ; }
  }
  printf("%d\n",best) ;     
}


int main() {
  float x,y,r ;
  int n ;

  for(;;) {
    scanf("%g %g %g",&x,&y,&r) ;
    if (r<0) break ;
    scanf("%d ",&n) ;
    solve(x,y,r,n) ;
  }

  return 0 ;
}
